import React from 'react';
import PropTypes from 'prop-types';

const initialState = {
  result: {
    command: '',
  },
};

export default class Input extends React.Component {
  static propTypes = {
    onSubmit: PropTypes.func.isRequired,
  }

  constructor() {
    super();
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleFormValueChange = {
      command: this.handleFormValueChange.bind(this, 'command'),
    };

    this.state = initialState;
  }

  handleSubmit(e) {
    e.preventDefault();
    this.props.onSubmit(this.state.result);
    this.setState(initialState);
  }

  handleFormValueChange(name, {
    target: {
      value,
    },
  }) {
    this.setState(old => ({
      ...old,
      result: {
        ...old.result,
        [name]: value,
      },
    }));
  }

  render() {
    return (
      <div className="input">
        <form onSubmit={this.handleSubmit}>
          <input type="text" value={this.state.result.command} name="command" onChange={this.handleFormValueChange.command} />
          <input type="submit" value="OK" />
        </form>
      </div>
    );
  }
}
