import React from 'react';

import style from './Log.styl';

const LogItem = ({
  isServer,
  children,
}) => (
  <div className={[
    'line',
    isServer
      ? 'line-by-server'
      : 'line-by-client',
  ]
    .map(n => style[n])
    .join(' ')}
  >
    {children}
  </div>
);

export default class Log extends React.Component {
  render() {
    return (
      <div className={style.log}>
        {this.props.log.map(({
          isServer,
          text,
        }, index) => (
          <LogItem isServer={isServer}>{text}</LogItem>
        ))}
      </div>
    );
  }
}
