import React from 'react';
import PropTypes from 'prop-types';

import style from './Login.styl';

export default class Login extends React.Component {
  static propTypes = {
    onSubmit: PropTypes.func.isRequired,
  }

  constructor() {
    super();
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleFormValueChange = {
      hostname: this.handleFormValueChange.bind(this, 'hostname'),
      password: this.handleFormValueChange.bind(this, 'password'),
      port: this.handleFormValueChange.bind(this, 'port'),
    };

    this.state = {
      result: {
        hostname: '',
        password: '',
        port: 11776,
      },
    };
  }

  handleSubmit(e) {
    e.preventDefault();
    this.props.onSubmit(this.state.result);
  }

  handleFormValueChange(name, {
    target: {
      value,
    },
  }) {
    this.setState(old => ({
      ...old,
      result: {
        ...old.result,
        [name]: value,
      },
    }));
  }

  render() {
    return (
      <div className={style.loginBox}>
        <form onSubmit={this.handleSubmit}>
          <div>
            <label className={style.label} htmlFor="rconServerName">Hostname:</label>
            <input className={style.input} type="text" value={this.state.result.hostname} name="rconServerName" onChange={this.handleFormValueChange.hostname} />
          </div>
          <div>
            <label className={style.label} htmlFor="rconPort">Port:</label>
            <input className={style.input} type="number" value={this.state.result.port} name="rconPort" onChange={this.handleFormValueChange.port} />
          </div>
          <div>
            <label className={style.label} htmlFor="rconPassword">Password:</label>
            <input className={style.input} type="password" value={this.state.result.password} name="rconPassword" onChange={this.handleFormValueChange.password} />
          </div>
          <input className={style.submit} type="submit" value="OK" />
        </form>
      </div>
    );
  }
}
